# You Don't Know JS: Async & Performance

## Table of Contents

* Foreword
* Preface
* Chapter 1: Asynchrony: Now & Later
	* A Program In Chunks
	* Event Loop
	* Parallel Threading
	* Concurrency
	* Jobs
	* Statement Ordering
* Chapter 2: Callbacks
	* Continuations
	* Sequential Brain
	* Trust Issues
	* Trying To Save Callbacks
* Chapter 3: Promises
	* What is a Promise?
	* Thenable Duck-Typing
	* Promise Trust
	* Chain Flow
	* Error Handling
	* Promise Patterns
	* Promise API Recap
	* Promise Limitations
* Chapter 4: Generators
	* Breaking Run-to-completion
	* Generator'ing Values
	* Iterating Generators Asynchronously
	* Generators + Promises
	* Generator Delegation
	* Generator Concurrency
	* Thunks
	* Pre-ES6 Generators
* Chapter 5: Program Performance
	* Web Workers
	* SIMD
	* asm.js
* Chapter 6: Benchmarking & Tuning
	* Benchmarking
	* Context Is King
	* jsPerf.com
	* Writing Good Tests
	* Microperformance
	* Tail Call Optimization (TCO)
* Appendix A: *asynquence* Library
* Appendix B: Advanced Async Patterns
* Appendix C: Acknowledgments

